diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-queue-container.cc ns-3.38/src/wifi/model/wifi-mac-queue-container.cc
--- ns-3.37/src/wifi/model/wifi-mac-queue-container.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-queue-container.cc	2023-03-16 20:54:23.864869400 -0700
@@ -19,6 +19,7 @@
 
 #include "wifi-mac-queue-container.h"
 
+#include "ctrl-headers.h"
 #include "wifi-mpdu.h"
 
 #include "ns3/mac48-address.h"
@@ -42,6 +43,7 @@
 
     NS_ABORT_MSG_UNLESS(pos == m_queues[queueId].cend() || GetQueueId(pos->mpdu) == queueId,
                         "pos iterator does not point to the correct container queue");
+    NS_ABORT_MSG_IF(!item->IsOriginal(), "Only the original copy of an MPDU can be inserted");
 
     auto [it, ret] = m_nBytesPerQueue.insert({queueId, 0});
     it->second += item->GetSize();
@@ -76,11 +78,14 @@
 WifiMacQueueContainer::GetQueueId(Ptr<const WifiMpdu> mpdu)
 {
     const WifiMacHeader& hdr = mpdu->GetHeader();
-    NS_ABORT_IF(hdr.IsCtl());
 
+    if (hdr.IsCtl())
+    {
+        return {WIFI_CTL_QUEUE, hdr.GetAddr2(), std::nullopt};
+    }
     if (hdr.IsMgt())
     {
-        return {WIFI_MGT_QUEUE, hdr.GetAddr2(), WIFI_TID_UNDEFINED};
+        return {WIFI_MGT_QUEUE, hdr.GetAddr2(), std::nullopt};
     }
     if (hdr.IsQosData())
     {
@@ -90,7 +95,7 @@
         }
         return {WIFI_QOSDATA_UNICAST_QUEUE, hdr.GetAddr1(), hdr.GetQosTid()};
     }
-    return {WIFI_DATA_QUEUE, hdr.GetAddr1(), WIFI_TID_UNDEFINED};
+    return {WIFI_DATA_QUEUE, hdr.GetAddr1(), std::nullopt};
 }
 
 const WifiMacQueueContainer::ContainerQueue&
@@ -118,52 +123,73 @@
 std::pair<WifiMacQueueContainer::iterator, WifiMacQueueContainer::iterator>
 WifiMacQueueContainer::DoExtractExpiredMpdus(ContainerQueue& queue) const
 {
+    std::optional<std::pair<WifiMacQueueContainer::iterator, WifiMacQueueContainer::iterator>> ret;
     iterator firstExpiredIt = queue.begin();
     iterator lastExpiredIt = firstExpiredIt;
     Time now = Simulator::Now();
 
-    while (lastExpiredIt != queue.end() && lastExpiredIt->expiryTime <= now)
+    do
     {
-        lastExpiredIt->expired = true;
-        // this MPDU is no longer queued
-        lastExpiredIt->ac = AC_UNDEF;
-        lastExpiredIt->deleter(lastExpiredIt->mpdu);
+        // advance firstExpiredIt and lastExpiredIt to skip all inflight MPDUs
+        for (firstExpiredIt = lastExpiredIt;
+             firstExpiredIt != queue.end() && !firstExpiredIt->inflights.empty();
+             ++firstExpiredIt, ++lastExpiredIt)
+        {
+        }
 
-        WifiContainerQueueId queueId = GetQueueId(lastExpiredIt->mpdu);
-        auto it = m_nBytesPerQueue.find(queueId);
-        NS_ASSERT(it != m_nBytesPerQueue.end());
-        NS_ASSERT(it->second >= lastExpiredIt->mpdu->GetSize());
-        it->second -= lastExpiredIt->mpdu->GetSize();
+        if (!ret)
+        {
+            // we get here in the first iteration only
+            ret = std::make_pair(firstExpiredIt, lastExpiredIt);
+        }
 
-        ++lastExpiredIt;
-    }
+        // advance lastExpiredIt as we encounter MPDUs with expired lifetime that are not inflight
+        while (lastExpiredIt != queue.end() && lastExpiredIt->expiryTime <= now &&
+               lastExpiredIt->inflights.empty())
+        {
+            lastExpiredIt->expired = true;
+            // this MPDU is no longer queued
+            lastExpiredIt->ac = AC_UNDEF;
+            lastExpiredIt->deleter(lastExpiredIt->mpdu);
+
+            WifiContainerQueueId queueId = GetQueueId(lastExpiredIt->mpdu);
+            auto it = m_nBytesPerQueue.find(queueId);
+            NS_ASSERT(it != m_nBytesPerQueue.end());
+            NS_ASSERT(it->second >= lastExpiredIt->mpdu->GetSize());
+            it->second -= lastExpiredIt->mpdu->GetSize();
 
-    if (lastExpiredIt != firstExpiredIt)
-    {
-        // transfer MPDUs with expired lifetime to the tail of m_expiredQueue
-        m_expiredQueue.splice(m_expiredQueue.end(), queue, firstExpiredIt, lastExpiredIt);
-        return {firstExpiredIt, m_expiredQueue.end()};
-    }
+            ++lastExpiredIt;
+        }
+
+        if (lastExpiredIt != firstExpiredIt)
+        {
+            // transfer non-inflight MPDUs with expired lifetime to the tail of m_expiredQueue
+            m_expiredQueue.splice(m_expiredQueue.end(), queue, firstExpiredIt, lastExpiredIt);
+            ret->second = m_expiredQueue.end();
+        }
+
+    } while (lastExpiredIt != firstExpiredIt);
 
-    return {m_expiredQueue.end(), m_expiredQueue.end()};
+    return *ret;
 }
 
 std::pair<WifiMacQueueContainer::iterator, WifiMacQueueContainer::iterator>
 WifiMacQueueContainer::ExtractAllExpiredMpdus() const
 {
-    iterator firstExpiredIt = m_expiredQueue.end();
+    std::optional<WifiMacQueueContainer::iterator> firstExpiredIt;
 
     for (auto& queue : m_queues)
     {
         auto [firstIt, lastIt] = DoExtractExpiredMpdus(queue.second);
 
-        if (firstIt != lastIt && firstExpiredIt == m_expiredQueue.end())
+        if (firstIt != lastIt && !firstExpiredIt)
         {
             // this is the first queue with MPDUs with expired lifetime
             firstExpiredIt = firstIt;
         }
     }
-    return {firstExpiredIt, m_expiredQueue.end()};
+    return std::make_pair(firstExpiredIt ? *firstExpiredIt : m_expiredQueue.end(),
+                          m_expiredQueue.end());
 }
 
 std::pair<WifiMacQueueContainer::iterator, WifiMacQueueContainer::iterator>
@@ -182,12 +208,16 @@
 std::hash<ns3::WifiContainerQueueId>::operator()(ns3::WifiContainerQueueId queueId) const
 {
     auto [type, address, tid] = queueId;
+    const std::size_t size = tid.has_value() ? 8 : 7;
 
-    uint8_t buffer[8];
+    uint8_t buffer[size];
     buffer[0] = type;
     address.CopyTo(buffer + 1);
-    buffer[7] = tid;
+    if (tid.has_value())
+    {
+        buffer[7] = *tid;
+    }
 
-    std::string s(buffer, buffer + 8);
+    std::string s(buffer, buffer + size);
     return std::hash<std::string>{}(s);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-queue-container.h ns-3.38/src/wifi/model/wifi-mac-queue-container.h
--- ns-3.37/src/wifi/model/wifi-mac-queue-container.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-queue-container.h	2023-03-16 20:54:23.864869400 -0700
@@ -25,6 +25,7 @@
 #include "ns3/mac48-address.h"
 
 #include <list>
+#include <optional>
 #include <tuple>
 #include <unordered_map>
 
@@ -34,16 +35,22 @@
 /// enumeration of container queue types
 enum WifiContainerQueueType
 {
-    WIFI_MGT_QUEUE = 0,
-    WIFI_QOSDATA_UNICAST_QUEUE = 1,
-    WIFI_QOSDATA_BROADCAST_QUEUE = 2,
-    WIFI_DATA_QUEUE = 3
+    WIFI_CTL_QUEUE = 0,
+    WIFI_MGT_QUEUE = 1,
+    WIFI_QOSDATA_UNICAST_QUEUE = 2,
+    WIFI_QOSDATA_BROADCAST_QUEUE = 3,
+    WIFI_DATA_QUEUE = 4
 };
 
 /**
  * Tuple (queue type, Address, TID) identifying a container queue.
  *
  * \note that Address has a different meaning depending on container queue type:
+ * - if container queue type is WIFI_CTL_QUEUE, Address is the Transmitter Address
+ * (TA) of the frames stored in the queue. We have distinct control queues
+ * depending on TA to distinguish among control frames that need to be sent
+ * over different links by 11be MLDs. MLD address as TA indicates that the frames
+ * can be sent on any link. TID is ignored.
  * - if container queue type is WIFI_MGT_QUEUE, Address is the Transmitter Address
  * (TA) of the frames stored in the queue. We have distinct management queues
  * depending on TA to distinguish among management frames that need to be sent
@@ -59,7 +66,8 @@
  * Transmitter Address (TA) because 11be stations are QoS stations and hence do
  * not send non-QoS Data frames. TID is ignored.
  */
-using WifiContainerQueueId = std::tuple<WifiContainerQueueType, Mac48Address, uint8_t>;
+using WifiContainerQueueId =
+    std::tuple<WifiContainerQueueType, Mac48Address, std::optional<uint8_t>>;
 
 } // namespace ns3
 
@@ -162,7 +170,7 @@
     uint32_t GetNBytes(const WifiContainerQueueId& queueId) const;
 
     /**
-     * Transfer MPDUs with expired lifetime in the container queue identified by
+     * Transfer non-inflight MPDUs with expired lifetime in the container queue identified by
      * the given QueueId to the container queue storing MPDUs with expired lifetime.
      *
      * \param queueId the QueueId identifying the container queue
@@ -171,8 +179,8 @@
      */
     std::pair<iterator, iterator> ExtractExpiredMpdus(const WifiContainerQueueId& queueId) const;
     /**
-     * Transfer MPDUs with expired lifetime in all the container queues to the container
-     * queue storing MPDUs with expired lifetime.
+     * Transfer non-inflight MPDUs with expired lifetime in all the container queues to the
+     * container queue storing MPDUs with expired lifetime.
      *
      * \return the range [first, last) of iterators pointing to the MPDUs transferred
      *         to the container queue storing MPDUs with expired lifetime
@@ -189,7 +197,7 @@
 
   private:
     /**
-     * Transfer MPDUs with expired lifetime in the given container queue to the
+     * Transfer non-inflight MPDUs with expired lifetime in the given container queue to the
      * container queue storing MPDUs with expired lifetime.
      *
      * \param queue the given container queue
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-queue-elem.cc ns-3.38/src/wifi/model/wifi-mac-queue-elem.cc
--- ns-3.37/src/wifi/model/wifi-mac-queue-elem.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-queue-elem.cc	2023-03-16 20:54:23.864869400 -0700
@@ -35,6 +35,7 @@
 WifiMacQueueElem::~WifiMacQueueElem()
 {
     deleter(mpdu);
+    inflights.clear();
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-queue-elem.h ns-3.38/src/wifi/model/wifi-mac-queue-elem.h
--- ns-3.37/src/wifi/model/wifi-mac-queue-elem.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-queue-elem.h	2023-03-16 20:54:23.864869400 -0700
@@ -25,6 +25,8 @@
 #include "ns3/callback.h"
 #include "ns3/nstime.h"
 
+#include <map>
+
 namespace ns3
 {
 
@@ -36,15 +38,24 @@
  *
  * Such elements can be accessed by the WifiMacQueue (via iterators) and
  * by the WifiMpdu itself (via the iterator it stores).
+ *
+ * Data frames transmitted by an 11be MLD must include link addresses as (RA, TA)
+ * which are different than the MLD addresses seen by the upper layer. In order
+ * to keep the original version of the data frame, we create an alias when a data
+ * frame is sent over a link. Aliases are stored in the map of in-flight MPDUs, which
+ * is indexed by the ID of the link over which the alias is in-flight.
+ * For consistency, also data frame transmitted by non-MLDs have an alias, which is
+ * simply a pointer to the original version of the data frame.
  */
 struct WifiMacQueueElem
 {
-    Ptr<WifiMpdu> mpdu;                    ///< MPDU stored by this element
-    Time expiryTime;                       ///< expiry time of the MPDU (set by WifiMacQueue)
-    AcIndex ac;                            ///< the Access Category associated with the queue
-                                           ///< storing this element (set by WifiMacQueue)
-    bool expired;                          ///< whether this MPDU has been marked as expired
-    Callback<void, Ptr<WifiMpdu>> deleter; ///< reset the iterator stored by the MPDU
+    Ptr<WifiMpdu> mpdu;                         ///< MPDU stored by this element
+    Time expiryTime{0};                         ///< expiry time of the MPDU (set by WifiMacQueue)
+    AcIndex ac{AC_UNDEF};                       ///< the Access Category associated with the queue
+                                                ///< storing this element (set by WifiMacQueue)
+    bool expired{false};                        ///< whether this MPDU has been marked as expired
+    std::map<uint8_t, Ptr<WifiMpdu>> inflights; ///< map of MPDUs in-flight on each link
+    Callback<void, Ptr<WifiMpdu>> deleter;      ///< reset the iterator stored by the MPDU
 
     /**
      * Constructor.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-queue.h ns-3.38/src/wifi/model/wifi-mac-queue.h
--- ns-3.37/src/wifi/model/wifi-mac-queue.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-queue.h	2023-03-16 20:54:23.868869300 -0700
@@ -281,6 +281,15 @@
      */
     void WipeAllExpiredMpdus();
 
+    /**
+     * Unlike the GetOriginal() method of WifiMpdu, this method returns a non-const
+     * pointer to the original copy of the given MPDU.
+     *
+     * \param mpdu the given MPDU
+     * \return the original copy of the given MPDU
+     */
+    Ptr<WifiMpdu> GetOriginal(Ptr<WifiMpdu> mpdu);
+
   protected:
     using Queue<WifiMpdu, WifiMacQueueContainer>::GetContainer;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.38/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.37/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2023-03-16 20:54:23.864869400 -0700
@@ -306,12 +306,15 @@
         // The given queueid has just been inserted in the queue info map.
         // Initialize the set of link IDs depending on the container queue type
         auto queueType = std::get<WifiContainerQueueType>(queueId);
+        auto address = std::get<Mac48Address>(queueId);
 
-        if (queueType == WIFI_MGT_QUEUE || queueType == WIFI_QOSDATA_BROADCAST_QUEUE)
+        if (queueType == WIFI_MGT_QUEUE ||
+            (queueType == WIFI_CTL_QUEUE && GetMac() && address != GetMac()->GetAddress()) ||
+            queueType == WIFI_QOSDATA_BROADCAST_QUEUE)
         {
             // these queue types are associated with just one link
             NS_ASSERT(GetMac());
-            auto linkId = GetMac()->GetLinkIdByAddress(std::get<Mac48Address>(queueId));
+            auto linkId = GetMac()->GetLinkIdByAddress(address);
             NS_ASSERT(linkId.has_value());
             queueInfoIt->second.linkIds = {*linkId};
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mac-trailer.h ns-3.38/src/wifi/model/wifi-mac-trailer.h
--- ns-3.37/src/wifi/model/wifi-mac-trailer.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mac-trailer.h	2023-03-16 20:54:23.868869300 -0700
@@ -26,7 +26,7 @@
 {
 
 /**
- * The length in octects of the IEEE 802.11 MAC FCS field
+ * The length in octets of the IEEE 802.11 MAC FCS field
  */
 static const uint16_t WIFI_MAC_FCS_LENGTH = 4;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mpdu.cc ns-3.38/src/wifi/model/wifi-mpdu.cc
--- ns-3.37/src/wifi/model/wifi-mpdu.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mpdu.cc	2023-03-16 20:54:23.868869300 -0700
@@ -36,24 +36,83 @@
 NS_LOG_COMPONENT_DEFINE("WifiMpdu");
 
 WifiMpdu::WifiMpdu(Ptr<const Packet> p, const WifiMacHeader& header)
-    : m_packet(p),
-      m_header(header)
+    : m_header(header)
 {
+    auto& original = std::get<OriginalInfo>(m_instanceInfo);
+    original.m_packet = p;
+
     if (header.IsQosData() && header.IsQosAmsdu())
     {
-        m_msduList = MsduAggregator::Deaggregate(p->Copy());
+        original.m_msduList = MsduAggregator::Deaggregate(p->Copy());
     }
-    m_inFlight = false;
 }
 
 WifiMpdu::~WifiMpdu()
 {
+    // Aliases can be queued (i.e., the original copy is queued) when destroyed
+    NS_ASSERT(std::holds_alternative<Ptr<WifiMpdu>>(m_instanceInfo) || !IsQueued());
+}
+
+bool
+WifiMpdu::IsOriginal() const
+{
+    return std::holds_alternative<OriginalInfo>(m_instanceInfo);
+}
+
+Ptr<const WifiMpdu>
+WifiMpdu::GetOriginal() const
+{
+    if (std::holds_alternative<OriginalInfo>(m_instanceInfo))
+    {
+        return this;
+    }
+    return std::get<ALIAS>(m_instanceInfo);
+}
+
+Ptr<WifiMpdu>
+WifiMpdu::CreateAlias(uint8_t linkId) const
+{
+    NS_LOG_FUNCTION(this << +linkId);
+    NS_ABORT_MSG_IF(!std::holds_alternative<OriginalInfo>(m_instanceInfo),
+                    "This method can only be called on the original version of the MPDU");
+    NS_ABORT_MSG_IF(!IsQueued(),
+                    "This method can only be called if the MPDU is stored in a MAC queue");
+
+    auto alias = Ptr<WifiMpdu>(new WifiMpdu, false);
+
+    alias->m_header = m_header; // copy the MAC header
+    alias->m_instanceInfo = Ptr(const_cast<WifiMpdu*>(this));
+    NS_ASSERT(alias->m_instanceInfo.index() == ALIAS);
+
+    return alias;
+}
+
+WifiMpdu::OriginalInfo&
+WifiMpdu::GetOriginalInfo()
+{
+    if (auto original = std::get_if<ORIGINAL>(&m_instanceInfo))
+    {
+        return *original;
+    }
+    auto& origInstanceInfo = std::get<Ptr<WifiMpdu>>(m_instanceInfo)->m_instanceInfo;
+    return std::get<OriginalInfo>(origInstanceInfo);
+}
+
+const WifiMpdu::OriginalInfo&
+WifiMpdu::GetOriginalInfo() const
+{
+    if (auto original = std::get_if<ORIGINAL>(&m_instanceInfo))
+    {
+        return *original;
+    }
+    const auto& origInstanceInfo = std::get<Ptr<WifiMpdu>>(m_instanceInfo)->m_instanceInfo;
+    return std::get<OriginalInfo>(origInstanceInfo);
 }
 
 Ptr<const Packet>
 WifiMpdu::GetPacket() const
 {
-    return m_packet;
+    return GetOriginalInfo().m_packet;
 }
 
 const WifiMacHeader&
@@ -77,7 +136,7 @@
 uint32_t
 WifiMpdu::GetPacketSize() const
 {
-    return m_packet->GetSize();
+    return GetPacket()->GetSize();
 }
 
 uint32_t
@@ -95,7 +154,7 @@
 Ptr<Packet>
 WifiMpdu::GetProtocolDataUnit() const
 {
-    Ptr<Packet> mpdu = m_packet->Copy();
+    Ptr<Packet> mpdu = GetPacket()->Copy();
     mpdu->AddHeader(m_header);
     AddWifiMacTrailer(mpdu);
     return mpdu;
@@ -108,12 +167,16 @@
     NS_LOG_FUNCTION(this << *msdu);
     NS_ABORT_MSG_IF(!msdu->GetHeader().IsQosData() || msdu->GetHeader().IsQosAmsdu(),
                     "Only QoS data frames that do not contain an A-MSDU can be aggregated");
+    NS_ABORT_MSG_IF(!std::holds_alternative<OriginalInfo>(m_instanceInfo),
+                    "This method can only be called on the original version of the MPDU");
 
-    if (m_msduList.empty())
+    auto& original = std::get<OriginalInfo>(m_instanceInfo);
+
+    if (original.m_msduList.empty())
     {
         // An MSDU is going to be aggregated to this MPDU, hence this has to be an A-MSDU now
         Ptr<const WifiMpdu> firstMsdu = Create<const WifiMpdu>(*this);
-        m_packet = Create<Packet>();
+        original.m_packet = Create<Packet>();
         DoAggregate(firstMsdu);
 
         m_header.SetQosAmsdu();
@@ -159,16 +222,18 @@
                                                          : msdu->GetHeader().GetAddr4()));
     hdr.SetLength(static_cast<uint16_t>(msdu->GetPacket()->GetSize()));
 
-    m_msduList.emplace_back(msdu->GetPacket(), hdr);
+    auto& original = std::get<OriginalInfo>(m_instanceInfo);
+
+    original.m_msduList.emplace_back(msdu->GetPacket(), hdr);
 
     // build the A-MSDU
-    NS_ASSERT(m_packet);
-    Ptr<Packet> amsdu = m_packet->Copy();
+    NS_ASSERT(original.m_packet);
+    Ptr<Packet> amsdu = original.m_packet->Copy();
 
     // pad the previous A-MSDU subframe if the A-MSDU is not empty
-    if (m_packet->GetSize() > 0)
+    if (original.m_packet->GetSize() > 0)
     {
-        uint8_t padding = MsduAggregator::CalculatePadding(m_packet->GetSize());
+        uint8_t padding = MsduAggregator::CalculatePadding(original.m_packet->GetSize());
 
         if (padding)
         {
@@ -180,70 +245,119 @@
     Ptr<Packet> amsduSubframe = msdu->GetPacket()->Copy();
     amsduSubframe->AddHeader(hdr);
     amsdu->AddAtEnd(amsduSubframe);
-    m_packet = amsdu;
+    original.m_packet = amsdu;
 }
 
 bool
 WifiMpdu::IsQueued() const
 {
-    return m_queueIt.has_value();
+    return GetOriginalInfo().m_queueIt.has_value();
 }
 
 void
 WifiMpdu::SetQueueIt(std::optional<Iterator> queueIt, WmqIteratorTag tag)
 {
-    m_queueIt = queueIt;
+    NS_ABORT_MSG_IF(!std::holds_alternative<OriginalInfo>(m_instanceInfo),
+                    "This method can only be called on the original version of the MPDU");
+
+    auto& original = std::get<OriginalInfo>(m_instanceInfo);
+    original.m_queueIt = queueIt;
 }
 
 WifiMpdu::Iterator
 WifiMpdu::GetQueueIt(WmqIteratorTag tag) const
 {
+    return GetQueueIt();
+}
+
+WifiMpdu::Iterator
+WifiMpdu::GetQueueIt() const
+{
     NS_ASSERT(IsQueued());
-    return m_queueIt.value();
+    return GetOriginalInfo().m_queueIt.value();
 }
 
 AcIndex
 WifiMpdu::GetQueueAc() const
 {
-    NS_ASSERT(IsQueued());
-    return (*m_queueIt)->ac;
+    return GetQueueIt()->ac;
 }
 
 Time
 WifiMpdu::GetExpiryTime() const
 {
-    NS_ASSERT(IsQueued());
-    return (*m_queueIt)->expiryTime;
+    return GetQueueIt()->expiryTime;
 }
 
 void
-WifiMpdu::SetInFlight()
+WifiMpdu::SetInFlight(uint8_t linkId) const
 {
-    m_inFlight = true;
+    GetQueueIt()->inflights[linkId] = Ptr(const_cast<WifiMpdu*>(this));
 }
 
 void
-WifiMpdu::ResetInFlight()
+WifiMpdu::ResetInFlight(uint8_t linkId) const
+{
+    GetQueueIt()->inflights.erase(linkId);
+}
+
+std::set<uint8_t>
+WifiMpdu::GetInFlightLinkIds() const
 {
-    m_inFlight = false;
+    if (!IsQueued())
+    {
+        return {};
+    }
+    std::set<uint8_t> linkIds;
+    for (const auto& [linkId, mpdu] : GetQueueIt()->inflights)
+    {
+        linkIds.insert(linkId);
+    }
+    return linkIds;
 }
 
 bool
 WifiMpdu::IsInFlight() const
 {
-    return m_inFlight;
+    return IsQueued() && !GetQueueIt()->inflights.empty();
+}
+
+void
+WifiMpdu::AssignSeqNo(uint16_t seqNo)
+{
+    NS_LOG_FUNCTION(this << seqNo);
+
+    m_header.SetSequenceNumber(seqNo);
+    // if this is an alias, set the sequence number on the original copy, too
+    if (auto originalPtr = std::get_if<ALIAS>(&m_instanceInfo))
+    {
+        (*originalPtr)->m_header.SetSequenceNumber(seqNo);
+    }
+    GetOriginalInfo().m_seqNoAssigned = true;
+}
+
+bool
+WifiMpdu::HasSeqNoAssigned() const
+{
+    return GetOriginalInfo().m_seqNoAssigned;
+}
+
+void
+WifiMpdu::UnassignSeqNo()
+{
+    GetOriginalInfo().m_seqNoAssigned = false;
 }
 
 WifiMpdu::DeaggregatedMsdusCI
 WifiMpdu::begin() const
 {
-    return m_msduList.cbegin();
+    return GetOriginalInfo().m_msduList.cbegin();
 }
 
 WifiMpdu::DeaggregatedMsdusCI
 WifiMpdu::end() const
 {
-    return m_msduList.cend();
+    return GetOriginalInfo().m_msduList.cend();
 }
 
 void
@@ -274,7 +388,7 @@
         os << ", residualLifetime=" << (GetExpiryTime() - Simulator::Now()).As(Time::US)
            << ", inflight=" << IsInFlight();
     }
-    os << ", packet=" << m_packet;
+    os << ", packet=" << GetPacket();
 }
 
 std::ostream&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-mpdu.h ns-3.38/src/wifi/model/wifi-mpdu.h
--- ns-3.37/src/wifi/model/wifi-mpdu.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-mpdu.h	2023-03-16 20:54:23.868869300 -0700
@@ -31,6 +31,8 @@
 
 #include <list>
 #include <optional>
+#include <set>
+#include <variant>
 
 namespace ns3
 {
@@ -50,8 +52,10 @@
 /**
  * \ingroup wifi
  *
- * WifiMpdu stores (const) packets along with their Wifi MAC headers
- * and the time when they were enqueued.
+ * WifiMpdu stores a (const) packet along with a MAC header. To support 802.11be
+ * Multi-Link Operation (MLO), a WifiMpdu variant, referred to as WifiMpdu alias,
+ * is added. A WifiMpdu alias stores its own MAC header and a pointer to the original
+ * copy of the WifiMpdu.
  */
 class WifiMpdu : public SimpleRefCount<WifiMpdu>
 {
@@ -66,6 +70,16 @@
     virtual ~WifiMpdu();
 
     /**
+     * \return whether this is the original version of the MPDU
+     */
+    bool IsOriginal() const;
+
+    /**
+     * \return the original version of this MPDU
+     */
+    Ptr<const WifiMpdu> GetOriginal() const;
+
+    /**
      * \brief Get the packet stored in this item
      * \return the packet stored in this item.
      */
@@ -182,21 +196,53 @@
     Ptr<Packet> GetProtocolDataUnit() const;
 
     /**
-     * Mark this MPDU as being in flight (only used if Block Ack agreement established).
+     * Mark this MPDU as being in flight on the given link.
+     *
+     * \param linkId the ID of the given link
      */
-    void SetInFlight();
+    void SetInFlight(uint8_t linkId) const;
     /**
-     * Mark this MPDU as not being in flight (only used if Block Ack agreement established).
+     * Mark this MPDU as not being in flight on the given link.
+     *
+     * \param linkId the ID of the given link
      */
-    void ResetInFlight();
+    void ResetInFlight(uint8_t linkId) const;
     /**
-     * Return true if this MPDU is in flight, false otherwise.
-     *
-     * \return true if this MPDU is in flight, false otherwise
+     * \return the set of IDs of the links on which this MPDU is currently in flight
+     */
+    std::set<uint8_t> GetInFlightLinkIds() const;
+    /**
+     * \return true if this MPDU is in flight on any link, false otherwise
      */
     bool IsInFlight() const;
 
     /**
+     * Set the sequence number of this MPDU (and of the original copy, if this is an alias)
+     * to the given value. Also, record that a sequence number has been assigned to this MPDU.
+     *
+     * \param seqNo the given sequence number
+     */
+    void AssignSeqNo(uint16_t seqNo);
+    /**
+     * \return whether a sequence number has been assigned to this MPDU
+     */
+    bool HasSeqNoAssigned() const;
+    /**
+     * Record that a sequence number is no (longer) assigned to this MPDU.
+     */
+    void UnassignSeqNo();
+
+    /**
+     * Create an alias for this MPDU (which must be an original copy) for transmission
+     * on the link with the given ID. Aliases have their own copy of the MAC header and
+     * cannot be used to perform non-const operations on the frame body.
+     *
+     * \param linkId the ID of the given link
+     * \return an alias for this MPDU
+     */
+    Ptr<WifiMpdu> CreateAlias(uint8_t linkId) const;
+
+    /**
      * \brief Print the item contents.
      * \param os output stream in which the data should be printed.
      */
@@ -211,11 +257,48 @@
      */
     void DoAggregate(Ptr<const WifiMpdu> msdu);
 
-    Ptr<const Packet> m_packet;        //!< The packet (MSDU or A-MSDU) contained in this queue item
-    WifiMacHeader m_header;            //!< Wifi MAC header associated with the packet
-    DeaggregatedMsdus m_msduList;      //!< The list of aggregated MSDUs included in this MPDU
-    std::optional<Iterator> m_queueIt; //!< Queue iterator pointing to this MPDU, if queued
-    bool m_inFlight;                   //!< whether the MPDU is in flight
+    /**
+     * \return the queue iterator stored by this object
+     */
+    Iterator GetQueueIt() const;
+
+    /**
+     * Private default constructor (used to construct aliases).
+     */
+    WifiMpdu() = default;
+
+    /**
+     * Information stored by both the original copy and the aliases
+     */
+    WifiMacHeader m_header; //!< Wifi MAC header associated with the packet
+
+    /**
+     * Information stored by the original copy only.
+     */
+    struct OriginalInfo
+    {
+        Ptr<const Packet> m_packet;        //!< MSDU or A-MSDU contained in this queue item
+        DeaggregatedMsdus m_msduList;      //!< list of aggregated MSDUs included in this MPDU
+        std::optional<Iterator> m_queueIt; //!< Queue iterator pointing to this MPDU, if queued
+        bool m_seqNoAssigned;              //!< whether a sequence number has been assigned
+    };
+
+    /**
+     * \return a reference to the information held by the original copy of the MPDU.
+     */
+    OriginalInfo& GetOriginalInfo();
+    /**
+     * \return a const reference to the information held by the original copy of the MPDU.
+     */
+    const OriginalInfo& GetOriginalInfo() const;
+
+    /// Information stored by the original copy and an alias, respectively
+    using InstanceInfo = std::variant<OriginalInfo, Ptr<WifiMpdu>>;
+
+    InstanceInfo m_instanceInfo; //!< information associated with the instance type
+    static constexpr std::size_t ORIGINAL =
+        0;                                  //!< index of original copy in the InstanceInfo variant
+    static constexpr std::size_t ALIAS = 1; //!< index of an alias in the InstanceInfo variant
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-net-device.cc ns-3.38/src/wifi/model/wifi-net-device.cc
--- ns-3.37/src/wifi/model/wifi-net-device.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-net-device.cc	2023-03-16 20:54:23.868869300 -0700
@@ -19,7 +19,8 @@
 
 #include "wifi-net-device.h"
 
-#include "wifi-mac.h"
+#include "frame-exchange-manager.h"
+#include "sta-wifi-mac.h"
 #include "wifi-phy.h"
 
 #include "ns3/channel.h"
@@ -60,7 +61,8 @@
                           MakePointerAccessor(&WifiNetDevice::GetChannel),
                           MakePointerChecker<Channel>(),
                           TypeId::DEPRECATED,
-                          "Use the Channel attribute of WifiPhy")
+                          "class WifiNetDevice; use the Channel "
+                          "attribute of WifiPhy")
             .AddAttribute("Phy",
                           "The PHY layer attached to this device.",
                           PointerValue(),
@@ -93,7 +95,7 @@
                           ObjectVectorValue(),
                           MakeObjectVectorAccessor(&WifiNetDevice::GetRemoteStationManager,
                                                    &WifiNetDevice::GetNRemoteStationManagers),
-                          MakeObjectVectorChecker<WifiPhy>())
+                          MakeObjectVectorChecker<WifiRemoteStationManager>())
             .AddAttribute("HtConfiguration",
                           "The HtConfiguration object.",
                           PointerValue(),
@@ -374,6 +376,30 @@
 Address
 WifiNetDevice::GetAddress() const
 {
+    Ptr<StaWifiMac> staMac;
+    std::set<uint8_t> linkIds;
+
+    /**
+     * Normally, the MAC address that the network device has to advertise to upper layers is
+     * the MLD address, if this device is an MLD, or the unique MAC address, otherwise.
+     * Advertising the MAC address returned by WifiMac::GetAddress() is therefore the right
+     * thing to do in both cases. However, there is an exception: if this device is a non-AP MLD
+     * associated with a single link AP (hence, no ML setup was done), we need to advertise the
+     * MAC address of the link used to communicate with the AP. In fact, if we advertised the
+     * MLD address, the AP could not forward a frame to us because it would not recognize our
+     * MLD address as the MAC address of an associated station.
+     */
+
+    // Handle the exception first
+    if (m_mac->GetTypeOfStation() == STA &&
+        (staMac = StaticCast<StaWifiMac>(m_mac))->IsAssociated() && m_mac->GetNLinks() > 1 &&
+        (linkIds = staMac->GetSetupLinkIds()).size() == 1 &&
+        !GetRemoteStationManager(*linkIds.begin())
+             ->GetMldAddress(m_mac->GetBssid(*linkIds.begin())))
+    {
+        return m_mac->GetFrameExchangeManager(*linkIds.begin())->GetAddress();
+    }
+
     return m_mac->GetAddress();
 }
 
@@ -504,7 +530,7 @@
     {
         type = NetDevice::PACKET_MULTICAST;
     }
-    else if (to == m_mac->GetAddress())
+    else if (to == GetAddress())
     {
         type = NetDevice::PACKET_HOST;
     }
